diff -ruN qmail-1.03-orig/qmail-smtpd.c qmail-1.03-ldap-20060201-orig/qmail-smtpd.c
--- qmail-1.03-orig/qmail-smtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-smtpd.c	2006-02-25 11:00:55.000000000 +0100
@@ -403,19 +1711,54 @@
 , { "ehlo", smtp_ehlo, flush }
 , { "rset", smtp_rset, 0 }
 , { "help", smtp_help, flush }
+#ifdef TLS_SMTPD
+, { "starttls", smtp_tls, flush }
+#endif
+#ifdef DATA_COMPRESS
+, { "dataz", smtp_dataz, flush }
+#endif
+, { "auth", smtp_auth, flush }
 , { "noop", err_noop, flush }
 , { "vrfy", err_vrfy, flush }
 , { 0, err_unimpl, flush }
 } ;
 
-void main()
+struct commands smtprestricted[] = {
+  { "quit", smtp_quit, flush }
+, { "helo", err_503or421, flush }
+, { "ehlo", err_503or421, flush }
+, { 0, err_badcommand, flush }
+};
+
+int main(int argc, char **argv)
 {
+#ifdef TLS_SMTPD
+  sig_alarmcatch(sigalrm);
+#endif
   sig_pipeignore();
   if (chdir(auto_qmail) == -1) die_control();
   setup();
   if (ipme_init() != 1) die_ipme();
+  if (greeting550 || greeting421) {
+    if (!stralloc_copys(&greeting,greeting550 ? greeting550 : greeting421))
+      die_nomem();
+    timeout = 20; /* reduce timeout so the abuser is kicked out faster */
+    if (greeting.len == 0 && greeting550)
+      stralloc_copys(&greeting,
+	  "Sorry, your mail was administratively denied. (#5.7.1)");
+    else if (greeting.len == 0 && greeting421)
+      stralloc_copys(&greeting,
+	  "Service temporarily not available (#4.3.2)");
+
+    smtp_line(greeting550 ? "554 " : "421 ");
+    if (errdisconnect) err_quit();
+    if (commands(&ssin,smtprestricted) == 0) die_read();
+    die_nomem();
+  }
   smtp_greet("220 ");
-  out(" ESMTP\r\n");
-  if (commands(&ssin,&smtpcommands) == 0) die_read();
+  if (commands(&ssin,smtpcommands) == 0) die_read();
   die_nomem();
+  /* NOTREACHED */
+  return 1;
 }
+
diff -ruN qmail-1.03-orig/qmail-smtpd.rules qmail-1.03-ldap-20060201-orig/qmail-smtpd.rules
--- qmail-1.03-orig/qmail-smtpd.rules	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-smtpd.rules	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,29 @@
+#
+# SMTP server rules.
+# Default rule is to accept mails but not to relay. Do not even think of setting
+# RELAYCLIENT on the default rule.
+# Other useful stuff:
+#  AUTHPREPEND: String that is prepended to the login in the received line
+#  AUTHREQUIRED: Allow sending of messages only from authenticated senders.
+#  BLOCKRELAYPROBE: reject recipients with and "!", "%" or double-"@"
+#  LDAPSOFTOK: Ignore ldap soft errors in RCPTCHECK and SENDERCHECK
+#  LOGLEVEL: Level of log verbosity
+#  MAXRCPTCOUNT: maximum number of RCPT TOs you accept
+#  NOBOUNCE: Rejects null sender bounces, use only in extreme cases
+#  NOPBS: Disable pop-befor-smtp feature (pbscheck).
+#  QMAILQUEUE: alternate mail queueing program
+#  RBL: If set turns on rbl checking.
+#  RBLONLYHEADER: only tag messages filtered by rbl checking.
+#  RCPTCHECK: Check if the recipient of a message really exists.
+#  REJECTEXEC: Reject DOS/Windows executables in mail attachements.
+#  RETURNMXCHECK: Rejects senders if they don't have a valid return MX.
+#  SANITYCHECK: Rejects senders without an @, no . or too long/short TLD
+#  SENDERCHECK: Check if the sender of a message really exists.
+#  SMTPAUTH: Enables SMTP-AUTH for remote clients.
+#  550GREETING: Rejects a connection right away with an 550 error
+#  SMTP550DISCONNECT: Disconnect the SMTP session if a 5xx error happens
+#  TARPITCOUNT: number of RCPT TOs you accept before you start tarpitting.
+#  TARPITDELAY: number of seconds of delay to introduce while tarpitting
+#
+#192.168.0.:allow,RELAYCLIENT=""
+:allow
diff -ruN qmail-1.03-orig/qmail-smtpd.sh qmail-1.03-ldap-20060201-orig/qmail-smtpd.sh
--- qmail-1.03-orig/qmail-smtpd.sh	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-smtpd.sh	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,35 @@
+#!/bin/sh
+exec 2>&1
+#
+# SMTP service 
+#
+QMAIL="%QMAIL%"
+ME="`head -1 $QMAIL/control/me`"
+CONCURRENCY=${CONCURRENCY:=50}
+QUSER="qmaild"
+
+PATH="$QMAIL/bin:$PATH"
+
+# source the environemt in ./env
+eval `env - PATH=$PATH envdir ./env awk '\
+	BEGIN { for (i in ENVIRON) \
+		if (i != "PATH") { \
+			printf "export %s=\"%s\"\\n", i, ENVIRON[i] \
+		} \
+	}'`
+
+# enforce some sane defaults
+QUSER=${QUSER:="qmaild"}
+PBSTOOL=${PBSTOOL:="$QMAIL/bin/pbscheck"}
+
+if [ X${NOPBS+"true"} = X"true" ]; then
+	unset PBSTOOL
+fi
+
+exec \
+	envuidgid $QUSER \
+	tcpserver -v -URl $ME -x$QMAIL/control/qmail-smtpd.cdb \
+	    ${CONCURRENCY:+"-c$CONCURRENCY"} ${BACKLOG:+"-b$BACKLOG"} 0 smtp \
+	$PBSTOOL \
+	$QMAIL/bin/qmail-smtpd
+
diff -ruN qmail-1.03-orig/qmail-start.c qmail-1.03-ldap-20060201-orig/qmail-start.c
--- qmail-1.03-orig/qmail-start.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-start.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,13 +1,19 @@
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
 #include "fd.h"
 #include "prot.h"
 #include "exit.h"
 #include "fork.h"
 #include "auto_uids.h"
 
-char *(qsargs[]) = { "qmail-send", 0 };
-char *(qcargs[]) = { "qmail-clean", 0 };
-char *(qlargs[]) = { "qmail-lspawn", "./Mailbox", 0 };
-char *(qrargs[]) = { "qmail-rspawn", 0 };
+const char *(qsargs[]) = { "qmail-send", 0 };
+const char *(qcargs[]) = { "qmail-clean", 0 };
+const char *(qlargs[]) = { "qmail-lspawn", "./Mailbox", 0 };
+const char *(qrargs[]) = { "qmail-rspawn", 0 };
+#ifdef EXTERNAL_TODO
+const char *(qtargs[]) = { "qmail-todo", 0};
+#endif
 
 void die() { _exit(111); }
 
@@ -18,16 +24,31 @@
 int pi4[2];
 int pi5[2];
 int pi6[2];
-
-void close23456() { close(2); close(3); close(4); close(5); close(6); }
+#ifdef EXTERNAL_TODO
+int pi7[2];
+int pi8[2];
+int pi9[2];
+int pi10[2];
+#endif
+
+void close23456() { 
+  close(2); close(3); close(4); close(5); close(6); 
+#ifdef EXTERNAL_TODO
+  close(7); close(8);
+#endif
+}
 
 void closepipes() {
   close(pi1[0]); close(pi1[1]); close(pi2[0]); close(pi2[1]);
   close(pi3[0]); close(pi3[1]); close(pi4[0]); close(pi4[1]);
   close(pi5[0]); close(pi5[1]); close(pi6[0]); close(pi6[1]);
+#ifdef EXTERNAL_TODO
+  close(pi7[0]); close(pi7[1]); close(pi8[0]); close(pi8[1]);
+	close(pi9[0]); close(pi9[1]); close(pi10[0]); close(pi10[1]);
+#endif
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -40,6 +61,10 @@
   if (fd_copy(4,0) == -1) die();
   if (fd_copy(5,0) == -1) die();
   if (fd_copy(6,0) == -1) die();
+#ifdef EXTERNAL_TODO
+  if (fd_copy(7,0) == -1) die();
+  if (fd_copy(8,0) == -1) die();
+#endif
 
   if (argv[1]) {
     qlargs[1] = argv[1];
@@ -70,6 +95,12 @@
   if (pipe(pi4) == -1) die();
   if (pipe(pi5) == -1) die();
   if (pipe(pi6) == -1) die();
+#ifdef EXTERNAL_TODO
+  if (pipe(pi7) == -1) die();
+  if (pipe(pi8) == -1) die();
+  if (pipe(pi9) == -1) die();
+  if (pipe(pi10) == -1) die();
+#endif
  
   switch(fork()) {
     case -1: die();
@@ -78,7 +109,7 @@
       if (fd_copy(1,pi2[1]) == -1) die();
       close23456();
       closepipes();
-      execvp(*qlargs,qlargs);
+      execvp(*qlargs,(char **)qlargs);
       die();
   }
  
@@ -90,7 +121,7 @@
       if (fd_copy(1,pi4[1]) == -1) die();
       close23456();
       closepipes();
-      execvp(*qrargs,qrargs);
+      execvp(*qrargs,(char **)qrargs);
       die();
   }
  
@@ -102,9 +133,37 @@
       if (fd_copy(1,pi6[1]) == -1) die();
       close23456();
       closepipes();
-      execvp(*qcargs,qcargs);
+      execvp(*qcargs,(char **)qcargs);
+      die();
+  }
+
+#ifdef EXTERNAL_TODO
+  switch(fork()) {
+    case -1: die();
+    case 0:
+      if (prot_uid(auto_uids) == -1) die();
+      if (fd_copy(0,pi7[0]) == -1) die();
+      if (fd_copy(1,pi8[1]) == -1) die();
+      close23456();
+      if (fd_copy(2,pi9[1]) == -1) die();
+      if (fd_copy(3,pi10[0]) == -1) die();
+      closepipes();
+      execvp(*qtargs,(char **)qtargs);
+      die();
+  }
+
+  switch(fork()) {
+    case -1: die();
+    case 0:
+      if (prot_uid(auto_uidq) == -1) die();
+      if (fd_copy(0,pi9[0]) == -1) die();
+      if (fd_copy(1,pi10[1]) == -1) die();
+      close23456();
+      closepipes();
+      execvp(*qcargs,(char **)qcargs);
       die();
   }
+#endif
  
   if (prot_uid(auto_uids) == -1) die();
   if (fd_copy(0,1) == -1) die();
@@ -114,7 +173,11 @@
   if (fd_copy(4,pi4[0]) == -1) die();
   if (fd_copy(5,pi5[1]) == -1) die();
   if (fd_copy(6,pi6[0]) == -1) die();
+#ifdef EXTERNAL_TODO
+  if (fd_copy(7,pi7[1]) == -1) die();
+  if (fd_copy(8,pi8[0]) == -1) die();
+#endif
   closepipes();
-  execvp(*qsargs,qsargs);
-  die();
+  execvp(*qsargs,(char **)qsargs);
+  return 111;
 }
diff -ruN qmail-1.03-orig/qmail-tcpok.c qmail-1.03-ldap-20060201-orig/qmail-tcpok.c
--- qmail-1.03-orig/qmail-tcpok.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-tcpok.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "strerr.h"
 #include "substdio.h"
 #include "lock.h"
@@ -11,10 +12,10 @@
 char buf[1024]; /* XXX: must match size in tcpto_clean.c, tcpto.c */
 substdio ss;
 
-void main()
+int main()
 {
   int fd;
-  int i;
+  unsigned int i;
 
   if (chdir(auto_qmail) == -1)
     strerr_die4sys(111,FATAL,"unable to chdir to ",auto_qmail,": ");
@@ -27,9 +28,9 @@
   if (lock_ex(fd) == -1)
     strerr_die4sys(111,FATAL,"unable to lock ",auto_qmail,"/queue/lock/tcpto: ");
 
-  substdio_fdbuf(&ss,write,fd,buf,sizeof buf);
+  substdio_fdbuf(&ss,subwrite,fd,buf,sizeof buf);
   for (i = 0;i < sizeof buf;++i) substdio_put(&ss,"",1);
   if (substdio_flush(&ss) == -1)
     strerr_die4sys(111,FATAL,"unable to clear ",auto_qmail,"/queue/lock/tcpto: ");
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/qmail-tcpto.c qmail-1.03-ldap-20060201-orig/qmail-tcpto.c
--- qmail-1.03-orig/qmail-tcpto.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-tcpto.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 /* XXX: this program knows quite a bit about tcpto's internals */
 
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "auto_qmail.h"
@@ -10,12 +11,15 @@
 #include "exit.h"
 #include "datetime.h"
 #include "now.h"
+#include "open.h"
+#include "readwrite.h"
+#include "byte.h"
 
 void die(n) int n; { substdio_flush(subfdout); _exit(n); }
 
-void warn(s) char *s;
+void warn(s) const char *s;
 {
- char *x;
+ const char *x;
  x = error_str(errno);
  substdio_puts(subfdout,s);
  substdio_puts(subfdout,": ");
@@ -32,7 +36,7 @@
 
 char tmp[FMT_ULONG + IPFMT];
 
-void main()
+int main()
 {
  int fdlock;
  int fd;
@@ -82,4 +86,6 @@
   }
 
  die(0);
+ /* NOTREACHED */
+ return 0;
 }
